﻿Romans x = new();

x.Number = 3;
Console.WriteLine(x.Number);  //It displays: 3
Console.WriteLine(x.Roman);   //It displays: III

x.Roman = "V";
Console.WriteLine(x.Number);  //It displays: 5
Console.WriteLine(x.Roman);   //It displays: V

class Romans {
    private int _number;

    //Define public property Number
    public int Number {
        //Define the getter
        get {
            return this._number;
        }

        //Define the setter
        set {
            if (value >= 1 && value <= 5) {
                this._number = value;
            }
            else {
                throw new Exception("Number not recognized");
            }
        }
    }

    //Define public property Roman
    public string Roman {
        //Define the getter
        get {
            Dictionary<int, string> number2roman = new() {
                { 1, "I" }, { 2, "II" }, { 3, "III" }, { 4, "IV" }, { 5, "V" }
            };
            return number2roman[this._number];
        }

        //Define the setter
        set {
            Dictionary<string, int> roman2number = new() {
                { "I", 1 }, { "II", 2 }, { "III", 3 }, { "IV", 4 }, { "V", 5 }
            };

            if (roman2number.ContainsKey(value)) {
                this._number = roman2number[value];
            }
            else {
                throw new Exception("Roman numeral not recognized");
            }
        }
    }
}
