﻿FahrenheitToCelsius x = new(-50);   //This calls the constructor 
                                    //which, in turn, calls the setter

Console.WriteLine(x.Temperature);   //This calls the getter.

x.Temperature = -60;                //This calls the setter
Console.WriteLine(x.Temperature);   //This calls the getter

x.Temperature = -700;               //This calls the setter and throws an error
Console.WriteLine(x.Temperature);   //This is never executed. The flow of execution
                                    //is stopped due to the previous statement.
class FahrenheitToCelsius {
    private double _temperature;    //This defines a private field

    //Define the constructor
    public FahrenheitToCelsius(double value) {
        this.Temperature = value;  //Property is initialized
    }

    //Define a public property
    public double Temperature {
        //Define the getter
        get {
            return 5.0 / 9.0 * (this._temperature - 32.0);
        }

        //Define the setter
        set {
            if (value >= -459.67) {
                this._temperature = value;
            }
            else {
                throw new Exception("There is no temperature below -459.67");
            }
        }
    }
}
